#include <iostream.h>

#include "board.h"
#include "bitboard.h"


BOARD BO_Move(BOARD board,MOVE move)
{
  bool color;
  char bb,bb2;
  MOVE  tmp;
  if (move.start == WSROCK){
    tmp.start = 7;
    tmp.stop  = 5;
    board = BO_Move(board,tmp);
    tmp.start = 4;
    tmp.stop  = 6;
    board = BO_Move(board,tmp);
    return board;
  }
  if (move.start == WBROCK){
    tmp.start = 0;
    tmp.stop  = 3;
    board = BO_Move(board,tmp);
    tmp.start = 4;
    tmp.stop  = 2;
    board = BO_Move(board,tmp);
    return board;
  }
  if (move.start == BSROCK){
    tmp.start = 63;
    tmp.stop  = 61;
    board = BO_Move(board,tmp);
    tmp.start = 60;
    tmp.stop  = 62;
    board = BO_Move(board,tmp);
    return board;
  }
  if (move.start == BBROCK){
    tmp.start = 56;
    tmp.stop  = 59;
    board = BO_Move(board,tmp);
    tmp.start = 60;
    tmp.stop  = 58;
    board = BO_Move(board,tmp);
    return board;
  }
  if (move.start == NOMOVE) return board;
  if (BB_GetValue(board.color[0],move.start)==1) color = WHITE;
  if (BB_GetValue(board.color[1],move.start)==1) color = BLACK;
  for(bb=0;bb<6;bb++) if (BB_GetValue(board.data[color][bb],move.start)==1) break;
  board.color[color]     = BB_SetValueTrue(board.color[color]    ,move.start);
  board.data[color][bb]  = BB_SetValueTrue(board.data[color][bb] ,move.start);
  if (BB_GetValue(board.color[1-color],move.stop)==1){
    for(bb2=0;bb2<6;bb2++) board.data[1-color][bb2] = BB_SetValueTrue(board.data[1-color][bb2],move.stop);
    board.color[1-color]     = BB_SetValueTrue(board.color[1-color],move.stop);
  }
  board.color[color]     = BB_SetValueFalse(board.color[color]   ,move.stop);
  board.data[color][bb]  = BB_SetValueFalse(board.data[color][bb],move.stop);
  if ((PS_GetY(move.stop)==8)&&(bb==PAWN)){
   board.data[WHITE][PAWN] = BB_SetValueFalse(board.data[WHITE][PAWN],move.stop);
   board.data[WHITE][QUEEN] = BB_SetValueTrue(board.data[WHITE][QUEEN],move.stop);
  }
  if ((PS_GetY(move.stop)==1)&&(bb==PAWN)){
   board.data[BLACK][PAWN] = BB_SetValueFalse(board.data[BLACK][PAWN],move.stop);
   board.data[BLACK][QUEEN] = BB_SetValueTrue(board.data[BLACK][QUEEN],move.stop);
  }
  return board;
}

BOARD BO_Convert(int board[8][8])
{
 BOARD bboard;
 for(int I=0;I<2;I++)
  for(int J=0;J<6;J++)
    bboard.data[I][J]=0;
 bboard.color[0]=0;
 bboard.color[1]=0;
 for(int I=0;I<8;I++)
 for(int J=0;J<8;J++)
   if (board[I][J]>0){
     bboard.color[0] = BB_SetValueFalse(bboard.color[0],I*8+J);
     bboard.data[0][board[I][J]-1] = BB_SetValueFalse(bboard.data[0][board[I][J]-1],I*8+J);
   }
   else if (board[I][J]<0){
     bboard.color[1] = BB_SetValueFalse(bboard.color[1],I*8+J);
     bboard.data[1][-board[I][J]-1] = BB_SetValueFalse(bboard.data[1][-board[I][J]-1],I*8+J);
   }
 return bboard;
}

void BO_Convert(BOARD board,int sortie[8][8])
{
  int piece;
  for(int coord=0;coord<64;coord++)
    if (BB_GetValue(board.color[0],coord)==1){
       for(piece=0;piece<6;piece++)
       if (BB_GetValue(board.data[0][piece],coord)==1) break;
       sortie[PS_GetY(coord)-1][PS_GetX(coord)-1] = piece+1;
    } else if (BB_GetValue(board.color[1],coord)==1){
       for(piece=0;piece<6;piece++)
       if (BB_GetValue(board.data[1][piece],coord)==1) break;
       sortie[PS_GetY(coord)-1][PS_GetX(coord)-1] = -piece-1;
    } else sortie[PS_GetY(coord)-1][PS_GetX(coord)-1] = 0;
}


int   BO_Quiet(BOARD board)
{

}
