#ifndef DATA_H
#define DATA_H

#ifndef TRUE
#define TRUE 0
#endif

#ifndef FALSE
#define FALSE 1
#endif

#define PAWN   0
#define KNIGHT 1
#define BISHOP 2
#define ROOK   3
#define QUEEN  4
#define KING   5

#define PAWN_VALUE    100
#define ROOK_VALUE    600
#define KNIGHT_VALUE  500
#define BISHOP_VALUE  400
#define QUEEN_VALUE  1200
#define MATE_VALUE   100000
#define FPLACEMENT_VALUE 20
#define SPLACEMENT_VALUE 10

#define WHITE 0
#define BLACK 1

#define NOMOVE 99
#define NOPOS  99

#define WBROCK 100
#define WSROCK 101
#define BBROCK 102
#define BSROCK 103

#define MAX_NB_RESULT 60

typedef unsigned long long int BITBOARD;
inline bool Parity(int num){if(((float)num/2)==(num/2))return TRUE;else return FALSE;}
typedef signed long int SLINT;

typedef char POS;
inline char  PS_GetX(POS pos){return pos-(pos/8)*8+1;}
inline char  PS_GetY(POS pos){return pos/8+1;}

class MOVE{
  public:
  POS start;
  POS stop;
};

class BOARD{
  public:
  BITBOARD data[2][6];
  BITBOARD color[2];
};


// communication with interface
void interface_update();
void interface_update(float num);

#endif

