#include <stdlib.h>
#include <stdio.h>
#include "debug.h"
#include "db.h"

// hascode
struct HASHCODE {
   BITBOARD code1;
   BITBOARD code2;
} HASHCODE;

// in ram
struct INDEX {
   struct HASHCODE hc;
   long pos;
} INDEX;

long int nbindex;
struct INDEX *index;

// final data
struct CHEADER {
   int nbmove;
} CHEADER;

struct CDATA {
   char start;
   char stop;
   char result;
} CDATA;

struct CHEADER cheader;
MOVE *cmove;

struct HASHCODE createHashCode(BOARD data)
{
  struct HASHCODE hashcode;
    hashcode.code1 = data.data[0][0];
    hashcode.code1 ^= data.data[0][1];
    hashcode.code1 ^= data.data[0][2];
    hashcode.code1 ^= data.data[0][3];
    hashcode.code1 ^= data.data[0][4];
    hashcode.code1 ^= data.data[0][5];
    hashcode.code1 ^= data.data[1][0];
    hashcode.code1 ^= data.data[1][1];
    hashcode.code1 ^= data.data[1][2];
    hashcode.code1 ^= data.data[1][3];
    hashcode.code1 ^= data.data[1][4];
    hashcode.code1 ^= data.data[1][5];

    hashcode.code2 = data.data[0][0] << 1;
    hashcode.code2 ^= data.data[0][1] >> 1;
    hashcode.code2 ^= data.data[0][2] << 2;
    hashcode.code2 ^= data.data[0][3] >> 2;
    hashcode.code2 ^= data.data[0][4] << 1;
    hashcode.code2 ^= data.data[0][5] >> 1;
    hashcode.code2 ^= data.data[1][0] << 2;
    hashcode.code2 ^= data.data[1][1] >> 2;
    hashcode.code2 ^= data.data[1][2] << 1;
    hashcode.code2 ^= data.data[1][3] >> 1;
    hashcode.code2 ^= data.data[1][4] << 2;
    hashcode.code2 ^= data.data[1][5] >> 2;
    hashcode.code2 ^= data.color[0] << 1;
    hashcode.code2 ^= data.color[1] >> 1;
    return hashcode;
}

void DB_Init()
{
 FILE *src;
 nbindex=0;
 src = fopen("./db/index.db","rb");
 if (src == NULL) error(cannot open file ./db/index.db);
 fread(&nbindex,sizeof(long int),1,src);
 index = new struct INDEX[nbindex];
 fread(index,sizeof(INDEX),nbindex,src);
 fclose(src);
}

int  DB_FindMove(BOARD board,char result)
{
 struct CDATA *buffer;
 int nbmove = 0;
 struct HASHCODE hc = createHashCode(board);
 MOVE *cmove_buffer;
 long int pos = -1;
 FILE *db;

 for(int I=0;I<nbindex;I++) {
    if ((hc.code1 == index[I].hc.code1)&&(hc.code2 == index[I].hc.code2)){
       pos = index[I].pos;
       break;
    }
 }
 if (pos == -1) {
    return -1;
 }

 db = fopen("./db/chess.db","rb");
 cout << " (find at pos : " << pos << ") ";
 if (db == NULL) error(cannot open file ./db/index.db);
// fsetpos(db,&pos);
 fseek(db,pos,SEEK_SET);
 fread(&cheader,sizeof(struct CHEADER),1,db);

 buffer = new struct CDATA[cheader.nbmove];
 fread(buffer,sizeof(struct CDATA),cheader.nbmove,db);
 fclose(db);

 for(int I=0;I<cheader.nbmove;I++) {
    if (buffer[I].result == result) {
       cmove_buffer = new MOVE[nbmove];
       for(int J=0;J<nbmove;J++) {
              cmove_buffer[J].start = cmove[J].start;
              cmove_buffer[J].stop = cmove[J].stop;
       }
       delete cmove;
       cmove = new MOVE[++nbmove];
       for(int J=0;J<nbmove-1;J++) {
              cmove[J].start = cmove_buffer[J].start;
              cmove[J].stop = cmove_buffer[J].stop;
       }
       cmove[nbmove-1].start = buffer[I].start;
       cmove[nbmove-1].stop = buffer[I].stop;
       delete cmove_buffer;
    }
 }

 return nbmove;
}

MOVE DB_GetMove(int num)
{
 return cmove[num];
}

