#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "bitboard.h"
#include "interface.h"
#include "board.h"
#include "ini_file.h"
#include "search.h"
#include "analyse.h"
#include "genmove.h"

/* XPM */
static const char *img_cursor[] = {
  /* width height num_colors chars_per_pixel */
  "    32    32        3            1",
  /* colors */
  "X c #000000",
  ". c #ffffff",
  "  c None",
  /* pixels */
  "                                ",
  "                                ",
  "      XXXXXXXXXXXX              ",
  "     X............XX            ",
  "   XXXXXXXXXXX......X           ",
  "  X...........X......X          ",
  "  XXXXXXXXX..........X          ",
  " X.........X.........X          ",
  "  XXXXXXX............X          ",
  " X...................X          ",
  "  XXXXXXX............X          ",
  "         X...........X          ",
  "          X..........X          ",
  "           X..........X         ",
  "            X..........X        ",
  "             X..........X       ",
  "              X..........X      ",
  "               X......XXXXX     ",
  "                X.XXXXXX        ",
  "                 XX             ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "                                ",
  "0,0"
};



static SDL_Cursor *init_cursor(const char *image[])
{
  int i, row, col;
  Uint8 data[4*32];
  Uint8 mask[4*32];
  int hot_x, hot_y;

  i = -1;
  for ( row=0; row<32; ++row ) {
    for ( col=0; col<32; ++col ) {
      if ( col % 8 ) {
        data[i] <<= 1;
        mask[i] <<= 1;
      } else {
        ++i;
        data[i] = mask[i] = 0;
      }
      switch (image[4+row][col]) {
        case 'X':
          data[i] |= 0x01;
          mask[i] |= 0x01;
          break;
        case '.':
          mask[i] |= 0x01;
          break;
        case ' ':
          break;
      }
    }
  }
  sscanf(image[4+row], "%d,%d", &hot_x, &hot_y);
  return SDL_CreateCursor(data, mask, 32, 32, hot_x, hot_y);
}

int updateEvent(INTERFACE *interface)
{
        SDL_Event event;
        while(SDL_PollEvent(&event)) {
                 switch(event.type)
                 {
                 case SDL_QUIT :
                         interface->end();
                 case SDL_KEYUP :
                         if(event.key.keysym.sym == SDLK_ESCAPE)
                         {
                                 interface->end();
                         }
                 }
        }
}

int INTERFACE::start()
{
 INI_FILE             conf;
 MOVE                 result[MAX_NB_RESULT];
 int                  nbresult;
 char                 *tmp;
 int                  nb;
 bool                 color = 0;

 int iboard[8][8]={{ 4, 2, 3, 5, 6, 3, 2, 4},
                   { 1, 1, 1, 1, 1, 1, 1, 1},
                   { 0, 0, 0, 0, 0, 0, 0, 0},
                   { 0, 0, 0, 0, 0, 0, 0, 0},
                   { 0, 0, 0, 0, 0, 0, 0, 0},
                   { 0, 0, 0, 0, 0, 0, 0, 0},
                   {-1,-1,-1,-1,-1,-1,-1,-1},
                   {-4,-2,-3,-5,-6,-3,-2,-4}};

// board init
 board = BO_Convert(iboard);

// sdl init
 cout << "SDL_Init();\n";
 SDL_Init( SDL_INIT_VIDEO | SDL_INIT_EVENTTHREAD );
 SDL_EventState( SDL_MOUSEBUTTONDOWN | SDL_KEYUP | SDL_QUIT, SDL_ENABLE );
 SDL_EventState( SDL_MOUSEBUTTONUP | SDL_KEYDOWN | SDL_ACTIVEEVENT |
                                        SDL_MOUSEMOTION | SDL_JOYAXISMOTION | SDL_JOYBALLMOTION |
                                        SDL_JOYHATMOTION | SDL_JOYBUTTONUP |  SDL_JOYBUTTONDOWN |
                                        SDL_SYSWMEVENT | SDL_VIDEORESIZE | SDL_USEREVENT, SDL_IGNORE );
 sdl_screen = SDL_SetVideoMode( bsize * 10, bsize * 10, 32, SDL_HWSURFACE | SDL_DOUBLEBUF );
 SDL_WM_SetCaption("Cinag - 0.102.5 - sauron@webmails.com", "Cinag");
 sdl_pieces = SDL_LoadBMP("./bitmaps/piece.bmp");
 SDL_SetColorKey(sdl_pieces, SDL_SRCCOLORKEY, SDL_MapRGB(sdl_pieces->format, 255, 0, 255));
 sdl_dialog = SDL_LoadBMP("./bitmaps/dialog.bmp");
 SDL_SetColorKey(sdl_dialog, SDL_SRCCOLORKEY, SDL_MapRGB(sdl_dialog->format, 255, 0, 255));
 sdl_progress = SDL_LoadBMP("./bitmaps/progress.bmp");
 SDL_SetColorKey(sdl_progress, SDL_SRCCOLORKEY, SDL_MapRGB(sdl_progress->format, 255, 0, 255));

 sdl_white = SDL_LoadBMP("./bitmaps/white.bmp");
 SDL_SetColorKey(sdl_white, SDL_SRCCOLORKEY, SDL_MapRGB(sdl_white->format, 255, 0, 255));
 SDL_SetAlpha(sdl_white,SDL_SRCALPHA,130);
 sdl_black = SDL_LoadBMP("./bitmaps/black.bmp");
 SDL_SetColorKey(sdl_black, SDL_SRCCOLORKEY, SDL_MapRGB(sdl_black->format, 255, 0, 255));
 SDL_SetAlpha(sdl_black,SDL_SRCALPHA,130);

 sdl_cursor = init_cursor(img_cursor);
 SDL_SetCursor(sdl_cursor);
 cout << "Start Game\n";

// reading conf.ini
 conf.read("conf.ini");

 tmp = conf.getcharvalue("GAME", "usercolor");
 if(strcmp(tmp, "white") == 0){
   usercolor = WHITE;
   color = BLACK;
 }
 if(strcmp(tmp, "black") == 0){
   color = WHITE;
   usercolor = BLACK;
 }
 *this << board;
 if(strcmp(tmp, "demo") == 0){
  MOVE move;
  for(;;){
    move = SE_Search(board,WHITE);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << move;
    *this << " - ";
    *this << board;
    move = SE_Search(board,BLACK);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << move;
    *this << "\n";
    *this << board;
  }
 }
 this->loop(color);
}

void INTERFACE::loop(bool color)
{
  int nb;
  MOVE move;
  if (color == WHITE)
  for(;;){
    move = SE_Search(board,WHITE);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << move;
    *this << " - ";
    *this << board;
    sdl_move.start = NOPOS;
    sdl_move.stop  = NOPOS;
    move.start = NOPOS;
    move.stop = NOPOS;
    for(;move.start==NOPOS||move.stop==NOPOS;) move = getmove(board,BLACK);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << board;
    *this << move;
    *this << "\n";
  }
  if (color == BLACK)
  for(;;){
    *this << board;
    sdl_move.start = NOPOS;
    sdl_move.stop  = NOPOS;
    move.start = NOPOS;
    move.stop = NOPOS;
    for(;move.start==NOPOS||move.stop==NOPOS;) move = getmove(board,WHITE);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << board;
    *this << move;
    *this << " - ";
    move = SE_Search(board,BLACK);
    board = BO_Move(board,move);
    this->AddToGame(move);
    *this << move;
    *this << "\n";
  }
}

const INTERFACE& INTERFACE::operator<< (BOARD buffer)
{
        SDL_Event event;
        int board[8][8];
        int i,j,num,let;
        bool c = WHITE;
        SDL_Rect r;
        SDL_Rect src, dest;
        SDL_Rect dialog_rect;


        BO_Convert(buffer,board);

        r.x = r.y = r.w = r.h = bsize;
        src.w = src.h = psize;

        for(i = 0 ; i < 8 ; i++)
        {
                for(j = 0 ; j < 8 ; j++)
                {
                        if( usercolor == WHITE ) num =  7-i;
                        else num = i;
                        if( usercolor == BLACK ) let = 7-j;
                        else let = j;
                        // draw square
                        if(c == WHITE)
                        {
                                if(j != 7) c = BLACK;
                                if( (num == PS_GetY(sdl_move.start)-1) && (let == PS_GetX(sdl_move.start)-1) )
                                     SDL_FillRect(sdl_screen, &r, SDL_MapRGB(sdl_pieces->format, 180, 180, 180));
                                else SDL_FillRect(sdl_screen, &r, SDL_MapRGB(sdl_pieces->format, 230, 230, 230));
                        }
                        else
                        {
                                if(j != 7) c = WHITE;
                                if( (num == PS_GetY(sdl_move.start)-1) && (let == PS_GetX(sdl_move.start)-1) )
                                     SDL_FillRect(sdl_screen, &r, SDL_MapRGB(sdl_pieces->format,100, 70, 80));
                                else SDL_FillRect(sdl_screen, &r, SDL_MapRGB(sdl_pieces->format, 50, 20, 30));
                        }

                        int piece = usercolor == WHITE ? board[7-i][j] : board[i][7-j];

                        // draw piece
                        if(piece != 0)
                        {
                                switch(piece)
                                {
                                case -6 : src.x = 5*psize; src.y = psize; break;
                                case -5 : src.x = 4*psize; src.y = psize; break;
                                case -3 : src.x = 2*psize; src.y = psize; break;
                                case -2 : src.x = 1*psize; src.y = psize; break;
                                case -4 : src.x = 3*psize; src.y = psize; break;
                                case -1 : src.x = 0*psize; src.y = psize; break;

                                case  6 : src.x = 5*psize; src.y = 0; break;
                                case  5 : src.x = 4*psize; src.y = 0; break;
                                case  3 : src.x = 2*psize; src.y = 0; break;
                                case  2 : src.x = 1*psize; src.y = 0; break;
                                case  4 : src.x = 3*psize; src.y = 0; break;
                                case  1 : src.x = 0*psize; src.y = 0; break;
                                }
                                piece = usercolor == BLACK ? 7-i : i;
                                dest.x = r.x + (bsize-psize)/2;
                                dest.y = r.y + (bsize-psize)/2;
                                SDL_BlitSurface(sdl_pieces, &src, sdl_screen, &dest);
                        }
                        r.x += bsize;
                }
                r.y += bsize;
                r.x = bsize;
        }

        if (buffer.data[0][5]==0){
          dialog_rect.x = bsize*5 - (int)(sdl_black->w)/2;
          dialog_rect.y = bsize*5 - (int)(sdl_black->h)/2;
          SDL_BlitSurface(sdl_black,NULL,sdl_screen,&dialog_rect);
          while(true) while(SDL_PollEvent(&event))
          {
                SDL_Flip(sdl_screen);
                switch(event.type)
                {
                case SDL_QUIT :
                        end();
                        break;
                case SDL_KEYUP :
                        end();
                        break;
                case SDL_MOUSEBUTTONDOWN :
                        end();
                        break;
                }
          }
        }
        if (buffer.data[1][5]==0){
          dialog_rect.x = bsize*5 - (int)(sdl_white->w/2);
          dialog_rect.y = bsize*5 - (int)(sdl_white->h/2);
          SDL_BlitSurface(sdl_white,NULL,sdl_screen,&dialog_rect);
          while(true) while(SDL_PollEvent(&event))
          {
                SDL_Flip(sdl_screen);
                switch(event.type)
                {
                case SDL_QUIT :
                        end();
                        break;
                case SDL_KEYUP :
                        end();
                        break;
                case SDL_MOUSEBUTTONDOWN :
                        end();
                        break;
                }
          }
        }
        SDL_Flip(sdl_screen);
}

const INTERFACE& INTERFACE::operator<< (char *buffer)
{
  cout << buffer;
}


const INTERFACE& INTERFACE::operator<< (int buffer)
{
  cout << buffer;
}

const INTERFACE& INTERFACE::operator<< (double buffer)
{
  cout << buffer;
}

const INTERFACE& INTERFACE::operator<< (float buffer)
{
  cout << buffer;
}

const INTERFACE& INTERFACE::operator<< (long int buffer)
{
  cout << buffer;
}

const INTERFACE& INTERFACE::operator<< (MOVE buffer)
{
 cout << (char)(PS_GetX(buffer.start)+96) << (int)PS_GetY(buffer.start);
 cout << (char)(PS_GetX(buffer.stop)+96) << (int)PS_GetY(buffer.stop);
}

MOVE INTERFACE::getmove(BOARD board,bool color)
{
        SDL_Event event;
        double tmp_x, tmp_y;
        MOVE result[MAX_NB_RESULT];

        while(SDL_PollEvent(&event))
        {
                switch(event.type)
                {
                case SDL_QUIT :
                        end();

                case SDL_KEYUP :
                        if(event.key.keysym.sym == SDLK_ESCAPE)
                        {
                                end();
                        }

                case SDL_MOUSEBUTTONDOWN :
                        tmp_x = floor((event.button.x - bsize) / bsize);
                        tmp_y = floor((event.button.y - bsize) / bsize);
                        if( tmp_x < 0.0 || tmp_x > 7.0 || tmp_y < 0.0 || tmp_y > 7.0) break;

                        if( usercolor == WHITE ) tmp_y = 7 - tmp_y;
                        if( usercolor == BLACK ) tmp_x = 7 - tmp_x;

                        if( sdl_move.start == NOPOS )
                        {
                                sdl_move.start = (char)tmp_y*8+(char)tmp_x;
                                break;
                        }

                        if( sdl_move.start != NOPOS )
                        {
                                sdl_move.stop = (char)tmp_y*8+(char)tmp_x;
                                if( sdl_move.start == sdl_move.stop ) sdl_move.start = NOPOS;
                                if ((sdl_move.start == 4)&&(sdl_move.stop == 6)){
                                  sdl_move.start = WSROCK;
                                  sdl_move.stop  = WSROCK;
                                }
                                if ((sdl_move.start == 4)&&(sdl_move.stop == 2)){
                                  sdl_move.start = WBROCK;
                                  sdl_move.stop  = WBROCK;
                                }
                                if ((sdl_move.start == 60)&&(sdl_move.stop == 62)){
                                  sdl_move.start = BSROCK;
                                  sdl_move.stop  = BSROCK;
                                }
                                if ((sdl_move.start == 60)&&(sdl_move.stop == 58)){
                                  sdl_move.start = BBROCK;
                                  sdl_move.stop  = BBROCK;
                                }

                                int nbresult = GN_Generate(board,color,result);
                                for(int I=0;I<nbresult;I++){
                                        if ((result[I].start==sdl_move.start)&&(result[I].stop==sdl_move.stop)) return sdl_move;
                                }
                                sdl_move.start = NOPOS;
                                sdl_move.stop = NOPOS;
                        }
                }
        }
        *this << board;
        return sdl_move;
}

void INTERFACE::update(float percent)
{
        SDL_Rect dialog_rect;

        updateEvent(this);

        dialog_rect.x = bsize*10 - (int)(sdl_dialog->w)-5;
        dialog_rect.y = bsize*10 - (int)(sdl_dialog->h)-5;
        if ((percent != 0)&&(isdialog == false)){
                isdialog = true;
                SDL_BlitSurface(sdl_dialog,NULL,sdl_screen,&dialog_rect);
                SDL_Flip(sdl_screen);
        }
        if (isdialog == true){
                SDL_Rect src;
                SDL_Rect dst;
                src.x = 0;
                src.y = 0;
                src.h = sdl_progress->h;
                src.w = (int)((float)sdl_progress->w*percent);
                dst.x = dialog_rect.x + 8;
                dst.y = dialog_rect.y + 6;
                SDL_BlitSurface(sdl_progress,&src,sdl_screen,&dst);
                SDL_Flip(sdl_screen);
        }
        if (percent == 0) isdialog = false;
        return;
}

void INTERFACE::end()
{
        SDL_FreeCursor(sdl_cursor);
        SDL_FreeSurface(sdl_pieces);
        SDL_FreeSurface(sdl_white);
        SDL_FreeSurface(sdl_black);
        SDL_FreeSurface(sdl_dialog);
        SDL_FreeSurface(sdl_screen);
        SDL_Quit();
        exit(0);
}

void INTERFACE::AddToGame(MOVE move)
{
  MOVE *buffer = new MOVE[GameNbMove+1];
  for(int I=0;I<GameNbMove;I++) buffer[I] = game[I];
  buffer[GameNbMove] = move;
  GameNbMove++;
  game = new MOVE[GameNbMove];
  for(int I=0;I<GameNbMove;I++) game[I] = buffer[I];
  delete buffer;
}

